<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
 *     	  Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
 *	  Use is subject to license terms.
-->
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="lastupdated" content="4Jul07">
<!-- p2 -->

<title>About Creating and Editing JSP, HTML, and Tag Files</title>
<link rel="stylesheet" href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
</head>
<body>

<h2>About Creating and Editing JSP, HTML, and Tag Files</h2>
<p><small> 
<a href="#seealso">See Also</a> 
</small></p> 
<p>The JSP Editor shows you the JavaServer<sup><small>TM</small></sup> Pages
  (JSP) code generated by the IDE for the page you are editing.  The JSP code is in XHTML format, and follows standard JSP conventions for
  the XML representation of a JSP page. The code uses the JavaServer Faces tag
  libraries to declare components, event handlers, validators, and so on. In
  addition, there are expressions written in the JavaServer Faces expression
  language (JSF EL). </p>
<p>Creating and editing JSP, HTML, and tag files is similar to creating and editing Java files. 
  The <a href="nbdocs://org.netbeans.modules.java.helpset/org/netbeans/modules/java/helpset/docs/editing/editing_about.html">Source Editor</a> provides support for HTML, JSP, and customized tags, including 
    code completion for the following JSP elements:</p>
<ul>
  <li>JSP tags</li>
  <li>JavaBeans that are defined with the <tt>&lt;jsp:useBean&gt;</tt> tag. </li>
  <li>Attributes that are defined in tag files</li>
  <li>Java code in scriptlets</li>
</ul>
<ul class="note">
  <li>The IDE provides many features for the creation and editing of XML documents. 
    For details, see <a href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/xml/xml_about.html">About 
    Editing XML Documents</a>. 
</ul>
<h3>Source Editor Features for JSP, HTML, and Tag Files</h3>

<p>When you open a JSP or HTML file in the IDE, a Palette (Ctrl-Shift-8) is displayed
on the right side of the Source Editor. Code snippets for many of the most common JSP and HTML tags
are provided -- grouped according to their function:
<ul>
	<li><b>HTML.</b> Table, Ordered List, Unordered List, Image, Link, MetaData.
	<li><b>HTML Forms.</b> Form, Multi-line Input, Checkbox, File Select, Text Input, drop down list,
	Radio Button, Button.
	<li><b>JSP.</b> Use Bean, Get Bean Property, Set Bean Property, JSTL Choose, 
	 JSTL If, JSTL For Each.
	<li><b>Database.</b> DB Query, DB Insert, DB Delete, DB Report, DB Update.

</ul>

<p>To use an item in the Palette, drag it from the Palette into the Source Editor and drop
 it exactly where you want the tags to appear. A dialog box appears. You can fill in values for
  the item's standard properties, click OK, and then the IDE generates the tags with your specified values.
<p>The IDE provides smart-case code completion
for JSP, HTML, and customized tags. When you start writing 
  a tag, the IDE offers code completion in upper case or lower case, depending 
  on the case you are using.</p>

<table cellpadding="3" cellspacing="0" border="0">
   <tr valign="top">
      <td><img src="../../images/tip.gif" alt="tip">&nbsp;</td>
      
    <td> To enable code completion for a JavaBean class, the JSP file must have 
      a valid <tt>jsp:useBean</tt> directive, the class must be in a package, 
      and the class must be available from the <tt>src</tt> 
      folder or from a library that is included in the compilation classpath. 
      To enable code completion for tags in tag libraries, the JSP file must have 
      a valid <tt>taglib</tt> directive for the library and the library must be 
      included in the compilation classpath.</td>
   </tr>
</table>

<p>Other examples of additional JSP support are the highlighting of JSP tags, 
  JSP directives, and EL expressions, <a href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/shortcuts/abbreviations-list.html">code 
 templates</a>, code 
  folding, the display of matching JSP tags, JSP delimiters (<tt>&lt;&gt;)</tt>, 
  and EL delimiters (<tt>{}</tt>), and <a href="nbdocs://org.netbeans.modules.java.helpset/org/netbeans/modules/java/helpset/docs/editing/editor_navigation.html">code 
  navigation</a> features such as hyperlinking for JSP identifiers. For example, 
  you can jump to the tag source file that defines a tag referenced in a JSP file 
  if you simultaneously hold down the Ctrl key and move the mouse over the tag, 
  as illustrated in <a href="jsp_usetaglib.html">Accessing a Custom Tag from 
  a JSP Page</a>. </p>
<p>To format selected code, right-click in the Source Editor and choose Format (Alt-Shift-F) 
 from the pop-up menu. If no code is selected, the IDE acts as if the 
  whole file has been selected. The IDE indents nested tags only if both the start 
  and end parent tags are in the selected area. Note that this action does not 
  format scriptlets. 
</p>
<dl>
	<dt><a name="seealso">See Also</a></dt>
<dd><a href="jsp_create.html">Creating a JSP File</a></dd>
<dd><a href="nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/html/html_create.html">Creating an HTML File</a></dd>
<dd><a href="about_jsp_encoding.html">About JSP Character Encoding</a></dd>
</dl>


<hr>
<small><a href="../../../credits.html">Legal Notices</a></small> 
<table border="0" cellpadding="50">
  <tr><td>&nbsp;</td></tr>
</table>
</body>
</html>
